import urllib2
from Screens.Screen import Screen
from Screens.MessageBox import MessageBox
from Components.ActionMap import NumberActionMap
from Components.Input import Input
from Components.Pixmap import Pixmap
from Components.FileList import FileList
from Screens.ChoiceBox import ChoiceBox
from Plugins.Plugin import PluginDescriptor

from enigma import iPlayableServicePtr
from Components.config import config
from enigma import eServiceReference
from Components.Sources.Source import Source
from Components.ServiceEventTracker import ServiceEventTracker
from enigma import iPlayableService
from enigma import eTimer
from Components.ActionMap import ActionMap

from enigma import eTimer
###########################################################################
# Media2ts1.02 : Coded by PCD, August 2007, enhanced from Demoplugin Test #
###########################################################################



class Test(Screen):
	skin = """
		<screen position="100,100" size="550,400" title="Test" >
			<!--widget name="text" position="0,0" size="550,25" font="Regular;20" /-->
			<widget name="list" position="10,0" size="190,250" scrollbarMode="showOnDemand" />
			<widget name="pixmap" position="200,0" size="190,250" />
		</screen>"""
	def __init__(self, session, args = None):
		self.skin = Test.skin
		Screen.__init__(self, session)

		self["list"] = FileList("/", matchingPattern = "^.*\.(png|avi|mp3|mpeg|ts)")
		self["pixmap"] = Pixmap()
		
		self["text"] = Input("1234", maxSize=True, type=Input.NUMBER)
				
		self["actions"] = NumberActionMap(["WizardActions", "InputActions"],
		{
			"ok": self.ok,
			"back": self.close,
			"left": self.keyLeft,
			"right": self.keyRight,
			"1": self.keyNumberGlobal,
			"2": self.keyNumberGlobal,
			"3": self.keyNumberGlobal,
			"4": self.keyNumberGlobal,
			"5": self.keyNumberGlobal,
			"6": self.keyNumberGlobal,
			"7": self.keyNumberGlobal,
			"8": self.keyNumberGlobal,
			"9": self.keyNumberGlobal,
			"0": self.keyNumberGlobal
		}, -1)
		
		self.onShown.append(self.openTest)
		
		mytimer= eTimer()

	def openTest(self):
		self.session.openWithCallback(self.callback, MessageBox, _("Test-Messagebox?"))

		self.session.open(InputBox)
	
	def callback(self, answer):
		print "answer:", answer
		self.close()
	
	def keyLeft(self):
		self["text"].left()
	
	def keyRight(self):
		self["text"].right()
	
	def ok(self):
		selection = self["list"].getSelection()
		if selection[1] == True: # isDir
			self["list"].changeDir(selection[0])
		else:
			self["pixmap"].instance.setPixmapFromFile(selection[0])
	
	def keyNumberGlobal(self, number):
		print "pressed", number
		self["text"].number(number)
		
	def test2 (self):
	        self.session.openWithCallback(self.test3, ChoiceBox, title="Play starting", list=[(_("OK"), "")])
                print "We are in test2"

        	
	def test3(self,returnValue):
                print "We are in test3 "
                self.play()
               
              	
	def play(self):
	        print "We are in play"
	        myfile = file(r"/etc/Media2ts.conf")
                data = []
                icount = 0
                for line in myfile.readlines():
                      data.append(icount)
                      data[icount] = line[:-1]
                      icount = icount+1
                      
                savefile = data[9]
                ref = "1:0:0:0:0:0:0:0:0:0:/media/hdd/movie/" + savefile
	        self.session.nav.playService(eServiceReference(ref))

                
        def timerfired(self):
                print "time ends"
                self.mytimer.start(5000)
        def starttimer(self):
                self.mytimer= eTimer()
                self.mytimer.timeout.get().append(self.timerfired)
                self.mytimer.start(5000)

        def stoptimer(self):
                self.mytimer.stop()

                
                       	
def main(session, **kwargs):
#	session.openWithCallback(test, MessageBox, _("Test-Messagebox?"), timeout = 10)
	print "In main"
#	session.openWithCallback(test, ChoiceBox, title="Select playlist item?", list=[(_("yes"), "yes"), (_("no"), "no"), (_("perhaps"), "perhaps"), (_("ask me tomorrow"), "ask me tomorrow"), (_("leave me alone with this!"), "yes")])
        myfile = file(r"/etc/Media2ts.conf")
        data = []
        icount = 0
        for line in myfile.readlines():
              print line
              data.append(icount)
              data[icount] = line[:-1]
              icount = icount+1
              
        hostaddr = "http://" + data[1] + ":" + data[3]
        print hostaddr
        fold = data[7]
        savefile = data[9]
  
        password_mgr = urllib2.HTTPPasswordMgrWithDefaultRealm()
        password_mgr.add_password(None, hostaddr,'admin','admin')
        handler = urllib2.HTTPBasicAuthHandler(password_mgr)
        opener = urllib2.build_opener(handler)
        furl = hostaddr + "/old/admin/dboxfiles.html?dir=" + fold
        f = opener.open(furl)

        ebuf = []
        ebuf.append((_("Exit "), ""))
        ebuf.append((_("DVD  "), ""))
        print ebuf[0]
        fileslist = []
        icount = 0
        for line in f.readlines():

              fileslist.append(icount)
              fileslist[icount] = (_(line[:-1]), "")
              if icount>0:
                    ebuf.append(fileslist[icount])
              icount = icount + 1
        
        print "files again"
        myfunction = len
        print fileslist[0]
        print fileslist[1]
        
        print ebuf
        
        movie = Test(session, None)
        f = movie.starttimer()
        movie.test2()

        f = movie.stoptimer()  
        session.openWithCallback(test, ChoiceBox, title="Please Select playlist item", list=ebuf)
      
        print "out of main"
		
def test(returnValue):
	print returnValue[0]
	filename = returnValue[0]
	myfile = file(r"/etc/Media2ts.conf")
        icount = 0
        data = []
        for line in myfile.readlines():
              print line
              data.append(icount)
              data[icount] = line[:-1]
              icount = icount+1
              
        hostaddr = "http://" + data[1] + ":" + data[3]
        dest = data[7] + data [9]
	cmd = hostaddr + "/?control=add&mrl="+returnValue[0]
	cmddvd = hostaddr + "/?control=add&mrl=dvdsimple://D:"
	cmd_file = hostaddr + "/?sout=%23duplicate{dst=std{access=file,mux=ts,dst=" + dest + "}}"
	cmd_divx = hostaddr + "/?sout=%23transcode{vcodec=mp2v,vb=3072,scale=1,acodec=mp2a,ab=192,channels=2}:duplicate{dst=std{access=file,mux=ts,dst=" + dest + "}}"
        cmd_dvd = hostaddr + "/?sout=%23transcode{vcodec=mp2v,vb=1024,scale=1,acodec=mpga,ab=192,channels=2}:duplicate{dst=std{access=file,mux=ts,dst=" + dest + "}} :sout-all"
        print "filename", filename
        print "filenale start3 = ", filename[0:3]
        print "filename end3 = ", filename[-4:-1]
        if filename[0:4] == "Exit":
              print "exit true"
              return
        else:
              cmd2 = cmd_file
              
        if filename[0:3] == "DVD":
              cmd2 = cmd_dvd
              cmd = cmddvd
              print "DVD true"
              
        if filename[-4:-1] == "ivx":
              cmd2 = cmd_divx
              print "divx true"
              
	print cmd
	password_mgr = urllib2.HTTPPasswordMgrWithDefaultRealm()
        password_mgr.add_password(None, hostaddr, 'admin','admin')
        handler = urllib2.HTTPBasicAuthHandler(password_mgr)
        opener = urllib2.build_opener(handler)
        f = opener.open(hostaddr + "/?control=stop")
        f = opener.open(hostaddr + "/?control=empty")
        f = opener.open(cmd)
        print cmd2
        f = opener.open(cmd2)
        f = opener.open(hostaddr + "/?control=play ")
        return

def Plugins(**kwargs):
	return PluginDescriptor(name="Media2ts", description="Plugin to make .ts files", where = PluginDescriptor.WHERE_PLUGINMENU, fnc=main)





























































































